# =================================================================
#
#    ŏɂmF 
#
#   {XNvg̓t[\tgłB쌠͕Ă܂B
#   cړIŎgpꍇɌARɎgpAJX^}CYA
#   Ĕzz\łB
#
#   ÃXNvggpȂ鑹Qɑ΂āA҂
#   ؂̐ӂ𕉂܂B
#
# =================================================================
#
#   zcgi.pm
#
#   Copyright(c) 2001-  Zumin., All rights reserved.
#
#   Email : mailto:webmaster@zumin.cside9.com
#   URL   : http://zumin.cside9.com/zumin/
#
# =================================================================
#   XVF
#   Date.       Ver.    Note.
#   2001.04.23  0.0.1   VK쐬
#   2001.04.25  0.0.2   Cookie ǉ
#   2001.04.26  0.0.3   Íi_~[jǉ
#   2001.04.28  0.0.4   _CNgǉ
#   2001.05.01  0.0.5   URLAJ[ɕύX鏈ǉ
#   2001.05.28  0.0.6   ÍiȈՔŁjǉ
#   2001.06.15  0.0.7   NbL[Lw\ɂB
# =================================================================


###################################################################
#
#	Use Library
#
###################################################################
require "jcode.pl";


###################################################################
#
#	Define Globals Œl
#
###################################################################

# {ꕶR[h^Cv`BLȊÕ^Cv(IATA AliasȂǁj
# ͎gpȂ悤ɂĂ̂ŒӂꂽB
$EUC       = 'EUC-JP';
$JIS       = 'iso-2022-jp';
$SJIS      = 'Shift_JIS';
$SAVERCODE = 'SAVER-ENCODE';


###################################################################
#
#	CGI p[^擾
#
###################################################################
sub GetParam
{
	my ($query, @params, $param);
	my $p = {};

	# HTTP Method
	my $method = uc $ENV{'REQUEST_METHOD'};

	# p[^擾
	if ($method eq 'POST') {
		read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
	} else {
		$query = $ENV{'QUERY_STRING'};
	}
	@params = split(/&/, $query);

	# p[^L[ƒlɕ
	foreach $param (@params) {
		my ($name, $value) = split(/=/, $param);

		# URL GR[hfR[h
		$value = &URLDecode($value);

		# {R[hϊEꕶ΍
		$value = &ConvStr($value, $SAVERCODE);

		# sR[h\nɓ
		$value =~ s/\r\n/\n/g;
		$value =~ s/\n\r/\n/g;
		$value =~ s/\r/\n/g;

		# Ō̉s͍폜
		chomp $value;

		# p[^nbVɃZbg
		$p->{$name} = $value;
	}

	return $p;
}

###################################################################
#
#	T[ot@CGR[h擾
#
###################################################################
sub GetSaverEncode
{
	$Static_enc;
	my @judge;

	# ''TvɂPUiϊĒׂĂ݂
	# ''́AEUCł́Ab4,c1,bb,fa łBB
	if ($Static_enc eq '') {

		@judge = unpack('C*', '');

		if ($judge[0] == 0xb4) {
			$Static_enc = $EUC;
		} else {
			$Static_enc = $SJIS;
		}
	}
	return $Static_enc;
}

###################################################################
#
#	{R[hϊEꕶ΍
#
###################################################################
sub ConvStr
{
	my ($str, $enc) = @_;

	#  $enc T[õt@CGR[h
	# 肷悤Ɋ҂郂[ĥƂ
	# T[o[̃t@CGR[h擾
	$enc = &GetSaverEncode() if ($enc eq $SAVERCODE);

	# EUCɕϊ
	if ($enc eq $EUC) {
		$str = &ConvStr2EUC($str);
	}
	# SJISɕϊ
	elsif ($enc eq $SJIS) {
		$str = &ConvStr2SJIS($str);
	}
	else {
		&FatalError("T[o̓{R[hs");
	}
	return $str;
}

###################################################################
#
#	EUC ւ̓{R[hϊEꕶ΍
#
###################################################################
sub ConvStr2EUC
{
	# EUC ϊ
	$str = &jcode::euc(@_);

	# pJiSpJiɕϊ
	jcode::h2z_euc(*str);

	# ---------------------------------------------------
	# @ˑϊB
	# MSg̓Agꂪȕ珇ΉB
	# ---------------------------------------------------

	# ې
	&jcode::tr(*str, "\xad\xa1", "\xff");	$str =~ s/\xff/(1)/g;
	&jcode::tr(*str, "\xad\xa2", "\xff");	$str =~ s/\xff/(2)/g;
	&jcode::tr(*str, "\xad\xa3", "\xff");	$str =~ s/\xff/(3)/g;
	&jcode::tr(*str, "\xad\xa4", "\xff");	$str =~ s/\xff/(4)/g;
	&jcode::tr(*str, "\xad\xa5", "\xff");	$str =~ s/\xff/(5)/g;
	&jcode::tr(*str, "\xad\xa6", "\xff");	$str =~ s/\xff/(6)/g;
	&jcode::tr(*str, "\xad\xa7", "\xff");	$str =~ s/\xff/(7)/g;
	&jcode::tr(*str, "\xad\xa8", "\xff");	$str =~ s/\xff/(8)/g;
	&jcode::tr(*str, "\xad\xa9", "\xff");	$str =~ s/\xff/(9)/g;
	&jcode::tr(*str, "\xad\xaa", "\xff");	$str =~ s/\xff/(10)/g;
	&jcode::tr(*str, "\xad\xab", "\xff");	$str =~ s/\xff/(11)/g;
	&jcode::tr(*str, "\xad\xac", "\xff");	$str =~ s/\xff/(12)/g;
	&jcode::tr(*str, "\xad\xad", "\xff");	$str =~ s/\xff/(13)/g;
	&jcode::tr(*str, "\xad\xae", "\xff");	$str =~ s/\xff/(14)/g;
	&jcode::tr(*str, "\xad\xaf", "\xff");	$str =~ s/\xff/(15)/g;
	&jcode::tr(*str, "\xad\xb0", "\xff");	$str =~ s/\xff/(16)/g;
	&jcode::tr(*str, "\xad\xb1", "\xff");	$str =~ s/\xff/(17)/g;
	&jcode::tr(*str, "\xad\xb2", "\xff");	$str =~ s/\xff/(18)/g;
	&jcode::tr(*str, "\xad\xb3", "\xff");	$str =~ s/\xff/(19)/g;
	&jcode::tr(*str, "\xad\xb4", "\xff");	$str =~ s/\xff/(20)/g;

	return $str;
}

###################################################################
#
#	SJIS ւ̓{R[hϊEꕶ΍
#
###################################################################
sub ConvStr2SJIS
{
	# SJIS ϊ
	$str = &jcode::sjis(@_);

	# pJiSpJiɕϊ
	jcode::h2z_sjis(*str);

	return $str;
}

###################################################################
#
#	NbL[擾
#
###################################################################
sub GetCookie
{
	my ($cookie_name) = @_;
	my $my_cookie = {};
	my %cookies;

	# HTTP Cookie S擾
	my @carry = split(/\;/, $ENV{'HTTP_COOKIE'});

	foreach my $c (@carry) {
		my ($name, $value) = split(/\=/, $c);
		$name =~ s/ //g;
		$cookies{$name} = $value;
	}

	# Ŏw肳ꂽOiKeyj Cookie Value
	# 擾B
	my @zarry = split(/\,/, $cookies{"$cookie_name"});

	foreach my $c (@zarry) {

		# Cookie Value ':'ŕAAPPŎgpKey
		#  Value oB
		my ($name, $value) = split(/\:/, $c);

		# URLGR[hfR[hB
		$name  = &URLDecode($name);
		$value = &URLDecode($value);

		$my_cookie->{$name} = $value;
	}

	return $my_cookie;
}

###################################################################
#
#	NbL[s
#
###################################################################
sub SetCookie
{
	my ($cookie_name, $my_cookie, $cookie_expire) = @_;
	my $cook;

	my @Month = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'); 
	my @Week  = ('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'); 

	# APPŎgpNbL[
	while (($name, $value) = each(%{$my_cookie})) {

		# URLGR[hB
		$name  = &URLEncode($name);
		$value = &URLEncode($value);

		# NbL[l񐶐
		$cook .= ($cook eq '') ? "$name\:$value" : "\,$name\:$value";
	}

	# NbL[̗Lݒ
	$cookie_expire ||= 30;
	my ($sec, $min, $hour, $day, $mon, $year,
		$wday, $yday, $is_dst) = gmtime(time + $cookie_expire*24*60*60);

	# 擾LRFČ`ɕϊ
	$year += 1900;
	$sec  = sprintf("%02d", $sec);
	$min  = sprintf("%02d", $min);
	$hour = sprintf("%02d", $hour);
	$day  = sprintf("%02d", $day);
	$mon  = $Month[$mon];
	$wday = $Week[$wday];

	# NbL[L񐶐
	my $expire = "$wday, $day\-$mon\-$year $hour:$min:$sec GMT";

	# Cookie sString
	my $set_cookie = "Set-Cookie: $cookie_name=$cook; expires=$expire\n";

	return $set_cookie;
}

###################################################################
#
#	_CNgHTTP Location wb_𐶐
#
###################################################################
sub SetRedirectHeader
{
	my ($nextURL) = @_;
	my $location;

	# HTTP Location wb_𐶐
	$location = "Status: 302 Moved\nLocation: $nextURL" ;

	return $location;
}

###################################################################
#
#	ƎɂÍiȈՔŁBlj
#
###################################################################
sub EnCrypt
{
	my ($pass, $key) = @_;
	my $ango;
	my $k;
	foreach my $d (unpack("C*", $key)) { $k += $d; }
	$k %= 16;
	foreach my $d (unpack("C*", $pass)) {
		$d += $k;
		$ango .= ($ango eq '') ? "$d" : "_$d";
	}
	return $ango;
}

###################################################################
#
#	ƎɂÍ̕iȈՔŁBlj
#
###################################################################
sub DeCrypt
{
	my ($ango, $key) = @_;
	my $pass;
	my $k;
	foreach my $d (unpack("C*", $key)) { $k += $d; }
	$k %= 16;
	my @ptmp;
	foreach my $d (split(/_/, $ango)) {
		$d -= $k;
		push(@ptmp, $d);
	}
	$pass = pack("C*", (@ptmp));
	return $pass;
}

###################################################################
#
#	CDATA ϊ
#
###################################################################
sub Cdata
{
	my($str) = @_;
	$str =~ s/&/&amp;/g;
	$str =~ s/\"/&quot;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/</&lt;/g;
	return $str;
}

###################################################################
#
#	URL GR[h
#
###################################################################
sub URLEncode
{
	my($str) = @_;
	$str =~ s/([^\w\-\*\. ])/sprintf("%%%02X", unpack('C', $1))/ge;
	$str =~ s/ /\+/g;
	return $str;
}

###################################################################
#
#	URL GR[hfR[h
#
###################################################################
sub URLDecode
{
	my ($str) = @_;
	$str =~ s/\+/ /g;
	$str =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
	return $str;
}

###################################################################
#
#	URL \IHTMLAJ[^Oɕϊ
#
###################################################################
sub SetHtmlAnker
{
	my ($str) = @_;
	$str =~ s/(https?:\/\/[\w\.\/\?\-=&#~\%\+]+)/<a href=\"$1\" target=\"_ztarget\">$1<\/a>/g;
	return $str;
}

###################################################################
#
#	vIG[
#
###################################################################
sub FatalError
{
	my ($emes, $lock) = @_;
	unlink("$lock") if ($lock ne '');
	die @_;
}

###################################################################
1
